package com.springjpa.repo;

import java.text.MessageFormat;

import org.springframework.beans.factory.annotation.Autowired;

import com.google.gson.JsonObject;
import com.springjpa.model.County;
import com.springjpa.persistence.DatastoreManager;

public class CountyRepoImpl implements CountyRepoCustom {

	static final String FIELDS = "[ {\"id\": \"id\", \"type\": \"int\"}, {\"id\": \"name\", \"type\": \"text\"} ]";
	static final String RECORD = "[ {\"id\": {0}, \"name\": \"{1}\"} ]";				//ebből lesz: [ {"id": 1, "name": "Heves megye"} ]
	static final String TABLE = "megye";
	
	static int ID = 1;
	
		
	String resourceId;
	

	/* CKAN-save lesz, aminek lényege, h REST-tel megy fel az adatbázisba :((
	 * @see com.springjpa.repo.CountyRepoCustom#saveSpec(com.springjpa.model.County)
	 */
	@Override
	public County saveSpec(County arg) {
		int id = (int)arg.getId();
		String name = arg.getName();
		//a fentiekből kell egy ilyen: [{"id": .. (nem kell idézőjel), "name": "..."}]
		String records = createRecord(id, name);
		String result = insertTableOf(TABLE, records);
		County ret = getCounty(result);
		return ret;
	}


	private County getCounty(String result) {
		JsonObject jobject = getArray(result, 0);
		County ret = new County();
		ret.setId(jobject.get("id").getAsInt());
		ret.setName(jobject.get("name").getAsString());
		return ret;
	}


	private String createRecord(int id, String name) {
		//innen: https://examples.javacodegeeks.com/core-java/text/messageformat/java-messageformat-example/
		MessageFormat mf = new MessageFormat(RECORD);
		Object[] objArray = {new Integer(id), name};
		String record = mf.format(objArray);
		return record;
	}

	@Override
	public boolean createTable() {
		boolean ret = true;
		resourceId = createTableOf(FIELDS);		//"[ {\"id\": \"id\", \"type\": \"int\"}, {\"id\": \"name\", \"type\": \"text\"} ]" );
		if (resourceId == null) {
			System.out.println("Nem sikerült az adatbázis létrehozása!");
			ret = false;
		}
			
		if (ret) {
			String check = renameResourceOf(resourceId, TABLE);
			if (check == null) {
				System.out.println("Nem sikerült az adatbázis-erőforrás átnevezése!");
				ret = false;
			}
		}
		return ret;	
	}



	@Override
	public void deleteTable() {
		// TODO Auto-generated method stub
		
	}

	
}
