package com.springjpa.repo;

import java.util.List;

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;

import com.springjpa.model.County;
import com.springjpa.model.Town;
import com.springjpa.model.TownShip;


public interface TownRepository extends CrudRepository<Town, Long>{
	
	List<Town> findByName(String name);
	
	List<Town> findAll();
	
	@Query("SELECT t.township FROM Town t INNER JOIN t.township ts WHERE ts.county.name = :county AND t.name = :town")
	TownShip findByTown(@Param("town") String town, @Param("county") String county);
		
}
