package com.springjpa;

import static org.hamcrest.CoreMatchers.containsString;
import static org.junit.Assert.assertThat;
import static org.junit.Assert.fail;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import org.junit.BeforeClass;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import com.springjpa.model.County;
import com.springjpa.model.Town;
import com.springjpa.model.TownShip;
import com.springjpa.repo.CountyRepository;
import com.springjpa.repo.TownRepository;
import com.springjpa.repo.TownShipRepository;


@RunWith(SpringRunner.class)
@SpringBootTest
public class SpringJpaApplicationTests {
	
	@Autowired
	private TownRepository townRepo;

	@Autowired
	private TownShipRepository tsRepo;
	
	@Autowired
	private CountyRepository countyRepo;
	

	@BeforeClass
	public static void init()  {
	}
	
	@Ignore
	@Test
	public void contextLoads() {
	}

	@Ignore
	@Test
	public void testTownsAll() {	
		System.out.println("\n-----testTownsAll---------");
		List<Town> towns = townRepo.findAll();
		for (Town town : towns) {
			System.out.println(town);
		}
	}
	

	@Ignore @Test
	public void testTownsInCountry() {
		System.out.println("\n-----testTownsInCountry---------");
		String NAME = "Ercsi";
		TownShip ret;
		List<County> counties = countyRepo.findAll();
		for (County county : counties) {
			ret = townRepo.findByTownAndCounty(NAME, county.getName());
			if (ret != null) {
				System.out.println(NAME + " ---> " + ret);
				break;
			}
		}
	}
	

	@Test														//mert rossz a megye :))
	public void testTownShipOfTown() {
		System.out.println("\n-----testTownShipOfTown---------");
		try{
			TownShip ts = townRepo.findByTownAndCounty("Ercsi", "Baranya megye");
			System.out.println(ts);
			System.out.println(ts);
			for (Town town : ts.getTowns()) {
				System.out.println("\t" + town);
			}
		} catch(Exception ex) {
			assertThat(ex.getMessage(), containsString("bad"));
		}	
		fail("expected SQLException because of bad county-name");
	}

	@Test														
	public void testTownShipOfTown2() {
		System.out.println("\n-----testTownShipOfTown2---------");
		try{
			TownShip ts = townRepo.findByTown("Ercsi");
			System.out.println(ts);
			System.out.println(ts);
			for (Town town : ts.getTowns()) {
				System.out.println("\t" + town);
			}
		} catch(Exception ex) {
			assertThat(ex.getMessage(), containsString("bad"));
		}	
	}


	@Ignore @Test
	public void testTownsOfCounty() {
		System.out.println("\n-----testTownsOfCounty---------");
		int ID = 7;
		List<Town> ret = new ArrayList<>();
		List<TownShip> tss = tsRepo.findAllForCounty(ID);
		for (TownShip ts : tss) { 
			List<Town> towns = townRepo.findAllForTS(ts.getId());
			for(Town town : towns)  {
				ret.add(town);
			}
		}
		System.out.println("Megye = " + ID);
		for (Town town : ret) {
			System.out.println("\t" + town);
		}			
		
	}


}
