package com.springjpa.persistence;

import java.util.List;

import com.springjpa.io.AddressForm;
import com.springjpa.model.Town;
import com.springjpa.model.TownShip;


public interface TableMethods { 
	
	/** Visszaadja az öszes megye nevét, de a lista végéhez hozzábiggyeszti a plus-t, ami ilyen "- összes megye -"
	 * @param plus
	 * @return
	 */
	List<String> getAllCountyNames(String plus);
	
	/** Beállítja az aktuális megyét sorszáma alapján
	 * @param id
	 */
	void setCountyById(long id);
	
	/** Beállítja az aktuális megyét név szerint
	 * @param district itt a megye neve
	 * @param plus az itteni szöveg ("- összes megye - ") is lehet a district értéke 
	 */
	void setCountyByName(String district, String plus);
	
	/** Az aktuáluis megyeszámot kitörli
	 * 
	 */
	void deleteCounty();
	
	/** Az aktuális megye össze települését adja vissza 
	 * @return
	 */
	List<Town> getCityList();
	
	
	/** Település alapján keressük az járást a megyében
	 * @param address benne megye és településnév
	 * @param plus az itteni szöveg ("- összes megye - ") is lehet a megye értéke 
	 * @return
	 */
	TownShip getTownShipOf(AddressForm address, String plus); 
	

	
		
	/** Ellenőrzi, h van-e azonos nevű település az országban (pl. ékezethiba miatt)
	 * @return
	 */
	boolean checkAllTowns();
	
	/** Megnézi, h megvan-e mind a 3 tábla: megye, járás, település
	 * @return meglevő táblák száma; ha 3, akkor teljesen jó
	 */
	int checkTables();
	
	

}
