//class-okat innen vettem: http://stackoverflow.com/questions/19891455/java-how-to-parse-json-for-geolocation
package com.springjpa.google;

import java.util.Arrays;
import java.util.List;

import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.cloud.cloudfoundry.com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import com.springjpa.io.Address;

@Service
public class GoogleMapClient {

	private static final String REST_SERVICE_URL = "https://maps.googleapis.com/maps/api/geocode/json?address=";
	private static final String KEY = "&key=AIzaSyDGgDthmnjFGGla6vWFTBF-BgU_O0_JXQk";
	
	private RestTemplate restTemplate = new RestTemplate();
	
	
	public LatLon getCoord(Address address) {
		Address ret = _getCoordAndZip(address, false);
		return ret != null ? ret.getGps() : null;
	}
	
	public Address getCoordAndZip(Address address) {
		return _getCoordAndZip(address, true);
	}
	
	@JsonIgnoreProperties(ignoreUnknown = true)
	public Address _getCoordAndZip(Address address, boolean zipToo) {
		String city = address.getCity();
		String county = address.getCounty();
		Address ret = new Address();
//		LatLon ret1 = null;
//		String ret2 = null;
		//ez a minta: http://maps.googleapis.com/maps/api/geocode/json?address=Cigánd,HU
		//address a vesszőig, HU automatikusan bemegy
		//http://maps... fix cím

		try	 {
			HttpHeaders headers = new HttpHeaders();
			headers.setAccept(Arrays.asList(MediaType.APPLICATION_JSON));
			HttpEntity<String> entity = new HttpEntity<String>(headers);
//System.out.println(REST_SERVICE_URL + city + "," + county + ", HU");			
																				//  "Cigánd"     "Heves megye"
			ResponseEntity<String> result = restTemplate.exchange(REST_SERVICE_URL + city + "," + county + ",HU" + KEY, HttpMethod.GET, entity, String.class);
//System.out.println(result);
			ObjectMapper mapper = new ObjectMapper();
			
//			System.out.println(result.getBody());
			Root root = mapper.readValue(result.getBody(), Root.class);
			
			for (Result res : root.getResults()) {
				List<AddressComponent> comps = res. getAddressComponents();
				
				if (zipToo) {
					for (AddressComponent comp : comps) {
						String zip = getPostalCode(comp);
						if (zip != null) {
							System.out.print(address.getFull() + "==>");
							ret.setZip(zip);
							System.out.println(zip);
							break;
						}
					}
				}
				
				if (isGoodDistrict(comps, city /*address.getDistrict()*/)) {
//					System.out.print(address.getFull() + "==>");
					double lat = Double.parseDouble(res.getGeometry().getLocation().getLat());
					double lon = Double.parseDouble(res.getGeometry().getLocation().getLng());
//					System.out.print(" lat = " + lat);
//					System.out.print(" lon = " + lon);
//					System.out.println();
if (Math.abs(lat) > 0.001d && Math.abs(lon) > 0.001d)
					ret.setGps(new LatLon(lat, lon));
				}
	        }
		} catch (Exception e) {
			System.out.println(e);
			ret = null;
			System.out.println(address.getFull() + ", HU" + " ->hiba");
		}

		return ret;
	}
	
	
	
	private String getPostalCode(AddressComponent comp) {
		for (String type : comp.getTypes()) {
			if ("postal_code".equals(type)) return comp.getLongName();
		}
		return null;
	}

	private String getAddress(String zip, String street, String number) {
		String ret = zip + " ";
		ret += "Budapest" + " ";
		ret += street + " ";
		ret += number;
		return ret;
	}

	private boolean isGoodDistrict(List<AddressComponent> comps, String name) {
		boolean ret = false;
		for (AddressComponent comp : comps) {
			if (name.equals(comp.getLongName()))
				return true;	
		}
		return ret;
	}

	
	
	
/*	
	public static void main(String[] args) {
		
		String city = "Balaton";
		String county = "Heves megye";
		
		Address address = new Address();
		address.setCity(city);
		address.setCounty(county);
//		address.setZip(zipcode);

		GoogleMapClient client = new GoogleMapClient();
		Address ok = client.getCoordAndZip(address);
		System.out.println(address.getFull() + "-->" + ok.getFull());
	}	
*/	
	
}

