package com.springjpa.io;

import com.springjpa.google.LatLon;

public class Address extends AddressForm {
	
	protected String zip = "";
	protected LatLon gps;
	
	
	
	public Address() {
		
	}
	
	public Address(String county, String city) {
		this.city = city;
		this.county = county;
	}
	

	public String getZip() {
		return zip;
	}

	public void setZip(String zip) {
		this.zip = zip;
	}

	public LatLon getGps() {
		return gps;
	}

	public void setGps(LatLon gps) {
		LatLon x = new LatLon();
		if (gps != null) {
			x.setLat(gps.getLat());
			x.setLon(gps.getLon());
		}
		this.gps = x;
	}
	
	public void modGps(double dlat, double dlon)  {
		this.gps.setLat(this.gps.getLat() + dlat);
		this.gps.setLon(this.gps.getLon() + dlon);
	}
	
	public String getCity() {
		return city;
	}

	public void setCity(String city) {
		this.city = city;
	}

	public String getCounty() {
		return county;
	}

	public void setCounty(String county) {
		this.county = county;
	}

	/**
	 * @return "1134 Budapest XIII. BP" VAGY "2081 Budaörs Pest megye 18.343567/34.98765"
	 */
	public String getFull()  {
		String ret = "";
		if (this.zip != "") ret += this.zip + " ";
		ret += this.city + " ";
		ret += this.county;
		if (gps != null) {
//			ret += " " + gps.getLat();
//			ret += "/" + gps.getLon();
			ret += " " + gps.toString();
		}
		return ret;
	}
		
		
	public String toString() {
		return this.getFull();
	}

}
