package com.springjpa.model;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.OneToMany;
import javax.persistence.Table;



@Entity
//@Table(name="megye2")
@Table(name="\"c63e6780-4f9b-494f-b456-8cf86251929c\"")
public class County implements java.io.Serializable {
	
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private long id;
	
	@Column(name="name", length=100, unique=true)
	private String name;
	
	@Column(name="cityname", length=100, unique=true)
	private String cityname;
	
//	@OneToMany(fetch=FetchType.EAGER)		//(cascade = {CascadeType.PERSIST})
//    @JoinTable(
//        name="Megye_Jarasok",
//        joinColumns = @JoinColumn( name="county_id"),
//        inverseJoinColumns = @JoinColumn( name="ts_id")
//    )
	@OneToMany(cascade = CascadeType.ALL, mappedBy = "county", fetch=FetchType.LAZY)
	private Set<TownShip> townships = new HashSet<>(0);
	
	
	public County() {
		
	}	
	public County(String name) {
		this.name = name;
	}
	
	public long getId() {
		return id;
	}
	public void setId(long id) {
		this.id = id;
	}
	
	
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	
	
	
    public String getCityname() {
		return cityname;
	}
	public void setCityname(String cityname) {
		this.cityname = cityname;
	}
	public Set<TownShip> getTownShips() {
    	return townships;
    }
    public void setTownShips(Set<TownShip> tss) {
    	townships = tss;
    }
    public void setTownShips(List<TownShip> tss) {
    	townships = new HashSet(tss);
    }
    public void addTownShip(TownShip ts) {
    	townships.add(ts);
    }


	public String toString() {
		return "MEGYE " + this.name + " " + (this.townships == null || this.townships.isEmpty() ? "null" : this.townships.size());
	}
	
	
	public String getNames() {
		return this.getName() + "/" + this.getCityname();
	}

}
