package com.springjpa.model;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;



@Entity
//@Table(name="jaras2")
@Table(name="\"26bf4d5b-2b92-41cb-9b28-394aed57344f\"")
public class TownShip implements java.io.Serializable {
	
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private long id;
	
	@Column(name="name", length=100, unique=true)
	private String name;
	
	@Column(name="cityname", length=100, unique=true)
	private String cityname;
	
//	@OneToMany(fetch=FetchType.EAGER)	//(cascade = {CascadeType.PERSIST})
//    @JoinTable(
//        name="Jaras_Telepulesek",
//        joinColumns = @JoinColumn( name="ts_id"),
//        inverseJoinColumns = @JoinColumn( name="town_id")
//    )
	@OneToMany(cascade = CascadeType.ALL, mappedBy = "township", fetch = FetchType.EAGER)
	private Set<Town> towns = new HashSet<Town>(0);
	
	@ManyToOne(fetch=FetchType.LAZY)
//	@JoinColumn(name = "county_id", nullable = false)
	@JoinColumn(name="county_id")
	private County county;
	
	public TownShip() {
		
	}
	public TownShip(String name) {
		this.name = name;
	}
	
	
	public long getId() {
		return id;
	}
	public void setId(long id) {
		this.id = id;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public Set<Town> getTowns() {
		return towns;
	}
	
	public Set<String> getTownNames()  {
		Set<String> ret = new HashSet<>();
		for (Town town : this.towns) {
			ret.add(town.getName());
		}
		return ret;
	}
	
	public void setTowns(Set<Town> towns) {
		this.towns = towns;
	}
	public void addTown(Town town)  {
		this.towns.add(town);
	}
	public County getCounty() {
		return county;
	}
	public void setCounty(County county) {
		this.county = county;
	}
	public String getCityname() {
		return cityname;
	}
	public void setCityname(String cityname) {
		this.cityname = cityname;
	}
	
	


	public String toString() {
		return "JÁRÁS "  + this.name + "/" + this.cityname + " " + (this.towns == null || this.towns.isEmpty() ? "null" : this.towns.size());
	}

	public String getNames() {
		return this.getName() + "/" + this.getCityname();
	}


}
