package com.springjpa.persistence;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.stereotype.Component;

import com.springjpa.io.AddressForm;
import com.springjpa.model.County;
import com.springjpa.model.Town;
import com.springjpa.model.TownShip;
import com.springjpa.repo.CountyRepository;
import com.springjpa.repo.TownRepository;
import com.springjpa.repo.TownShipRepository;

@Component
@ComponentScan(value = "com.springjpa")
public class TableRepositoryImpl implements TableRepo {
	
	
	@Autowired
	private TownRepository townRepo;

	@Autowired
	private TownShipRepository tsRepo;
	
	@Autowired
	private CountyRepository countyRepo;

	private String county;
	private long countyId;											//ha 0, akkor az összes település
	private static List<String> countyNames;
	private static List<Town> townAll;
	private List<Town> cities;

	

	
	@Override
	/** Kibővítés a VÉGÉRE!!!
	 * @param plus pl. "összes megye"
	 * @return
	 */
	public List<String> getAllCountyNames(String plus)  {
		List<String> ret = this.getAllCountyNames();
		ret.add(plus);
		return ret;
	}

	private List<String> getAllCountyNames()  {
		countyNames = new ArrayList<>();
		for(County county : countyRepo.findAll()) {
			countyNames.add(county.getName());
		}
		return countyNames;
	}

	@Override
	public void setCountyById(long id) {
		if (id == 0){
System.out.println("megye = " + "mind");
			this.countyId = 0;
			cities = townAll;
System.out.println("országos település adatok KÉSZ!");
		} else {
System.out.println("megye = " + id);
			this.countyId = id;
			cities = countyRepo.findAllForCounty(id);				//getTownsOf(id);
System.out.println("megyei település adatok KÉSZ!");
		}
	}

	@Override
	/** Település alapján keressük az járást a megyében
	 * @param address benne megye és településnév
	 * @param plus az itteni szöveg ("- összes megye - ") is lehet a megye értéke 
	 * @return
	 */
	public TownShip getTownShipOf(AddressForm address, String plus)  {
		TownShip ret = null;
//		if (plus.equals(address.getCounty())) {
			//"összes megye" van kijelölve --> keressük a megyét
			for (String county : countyNames) {
				ret = townRepo.findByTown(address.getCity());		
				if (ret != null) {
					address.setCounty(ret.getCounty().getName());
					break;	
				}
			}
//		} else {
//			 ret = townRepo.findByTown(address.getCity());			
//		}
		return ret;
	}

	@Override
	public List<Town> getCityList() {
		return cities;
	}

	
	@Override
	public List<String> getCountyNames() {
		return countyNames;
	}

	@Override
	public void setCountyByName(String name, String plus) {
		if (plus.equals(name)) {
//System.out.println("megye = " + "mind");
//			this.countyId = 0;
//			cities = townAll;				//getTownsOfAll();
//System.out.println("országos település adatok KÉSZ!");
			setCountyById(0);
		} else {
//			County county = countyRepo.findByName(name);
//			setCountyById(county.getId());
			setCountyById(countyRepo.getIdByName(name));
		}
	}

	@Override
	public void deleteCounty() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public boolean checkAllTowns()  {
		Set<String> set = new HashSet<>();
//		townAll = townRepo.findAll();
//		int i = 1;
//		for (Town town : townAll) {
//			set.add(town.getName());
//			i++;
//			if (i % 100 == 0) System.out.println(i + " ...");
//		}
//		return (townAll.size() != set.size());
		townAll = new ArrayList<>();
		List<County> counties = countyRepo.findAll();
		for (County county : counties) {
			System.out.println(county.getName() + " ...");
			List<Town> towns = countyRepo.findAllForCounty(county.getId());
			townAll.addAll(towns);
			for (Town town : towns) {
				set.add(town.getName());
			}
		}
		return true;
	}


	@Override
	public int checkTables() {
		// TODO Auto-generated method stub
		return 3;
	}
	
	

}
