package com.springjpa.repo;

import java.util.List;

import javax.persistence.QueryHint;

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.jpa.repository.QueryHints;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;

import com.springjpa.model.County;
import com.springjpa.model.Town;


public interface CountyRepository extends CrudRepository<County, Long>{
	
	List<County> findByName(String name);
	
	@Query("SELECT t FROM County t")
	List<County> findAll();
	
	@Query("SELECT t FROM County t WHERE t.id = :id")
	County findOne(@Param("id") long id);
	
	Long getIdByName(String name);
	
	@Query("SELECT t FROM Town t INNER JOIN t.township ts WHERE ts.county.id = :id")
	/** A megyéhez tartozó összes település
	 * @param id megye azonosító
	 * @return
	 */
	List<Town> findAllForCounty(@Param("id") long id);


}
