package com.springjpa.repo;

import java.util.List;

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;

import com.springjpa.model.Town;
import com.springjpa.model.TownShip;


public interface TownRepository extends CrudRepository<Town, Long>{
	
	List<Town> findByName(String name);
	
	List<Town> findAll();
		
	@Query("SELECT t FROM Town t WHERE t.id = :id")
	Town findOne(@Param("id") long id);
	
	@Query("SELECT t FROM Town t WHERE t.township.id = :id")
	/** A járáshoz tartozó összes település
	 * @param id járás azonosító
	 * @return
	 */
	List<Town> findAllForTS(@Param("id") long id);
	

	@Query("SELECT t.township FROM Town t INNER JOIN t.township ts WHERE t.name = :name" )
//	@Query("SELECT t.township FROM Town t INNER JOIN t.township ts WHERE ts.county.name = :county AND t.name = :name")
	/** Keressük a településhez tartozó járást 
	 * @param town "Magyarbóly"
	 * @return "Bólyi Járási Hivatal"
	 */
	TownShip findByTown(@Param("name") String name);			//, @Param("county") String county);
	
}
