package com.springjpa.repo;

import java.util.List;

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;

import com.springjpa.model.TownShip;

public interface TownShipRepository extends CrudRepository<TownShip, Long>{
	
	List<TownShip> findByName(String name);
	
	public List<TownShip> findAll();

	@Query("SELECT t FROM TownShip t WHERE t.id = :id")
	public TownShip findOne(@Param("id") long id);
		
	
	@Query("SELECT ts FROM TownShip ts WHERE ts.county.id = :id")
	/** A megyéhez tartozó összes járás
	 * @param id
	 * @return
	 */
	List<TownShip> findAllForCounty(@Param("id") long id);
	
	
}
